datablock ItemData(FluteItem) {
  category = "Weapon";
  className = "Weapon";

  shapeFile = "./models/flute_item.dts";
  emap = true;

  uiName = "Flute";
  iconName = "./icon_flute";

  image = FluteImage;
  canDrop = true;

  doColorShift = false;
  colorShiftColor = "0.75 0.75 0.75 1";

  friction = 0.599218;
};

datablock ShapeBaseImageData(FluteImage) {
  className = "WeaponImage";
  shapeFile = "./models/flute_image.dts";
  item = FluteItem;
  emap = true;

  mountPoint = 0;
  
  offset = "-0.52 0 0.09";
  eyeOffset = "-0.01 1.1 -0.75";

  // This is used by the instruments mod to determine what sounds to use
  // It's also used to check if an image is even an instrument to begin with
  instrumentType = "Flute";

  doColorShift = true;
  colorShiftColor = FluteItem.colorShiftColor;

  stateName[0]                     = "Activate";
  stateTimeoutValue[0]             = 0.15;
  stateTransitionOnTimeout[0]       = "Ready";
  stateSound[0]          = weaponSwitchSound;

  stateName[1]                     = "Ready";
  stateTransitionOnTriggerDown[1]  = "Play";
  stateAllowImageChange[1]         = true;
  stateSequence[1]  = "Ready";

  stateName[2]                    = "Play";
  stateTransitionOnTimeout[2]     = "PostPlay";
  stateTimeoutValue[2]            = 0.14;
  stateFire[2]                    = true;
  stateAllowImageChange[2]        = false;
  stateScript[2]                  = "onPlay";
  stateWaitForTimeout[2]      = true;
  stateEmitterTime[2]        = 0.05;

  stateName[3] = "PostPlay";
  stateEmitterTime[3]        = 0.05;
  stateEmitterNode[3]        = "muzzleNode";
  stateTimeoutValue[3]            = 0.01;
  stateTransitionOnTimeout[3]     = "Reload";

  stateName[4]      = "Reload";
  stateSequence[4]                = "Reload";
  stateTransitionOnTriggerUp[4]     = "Ready";
  stateSequence[4]  = "Ready";
};

// ------------------------------------------------------------------------------

function FluteImage::onMount(%this, %obj, %slot) {
  Parent::onMount(%this, %obj, %slot);
  
  %obj.playThread(2, armReadyBoth);

  %obj.hideNode("RHand");
  %obj.hideNode("RHook");
  %obj.hideNode("LHand");
  %obj.hideNode("LHook");
}

function FluteImage::onUnmount(%this, %obj, %slot) {
  Parent::onUnmount(%this, %obj, %slot);

  %obj.playThread(2, root);

  if (isObject(%obj.client)) {
    %obj.client.applyBodyParts();
    %obj.client.applyBodyColors();
  }
  else {
    applyDefaultCharacterPrefs(%obj);
  }
}

// ------------------------------------------------------------------------------

function FluteImage::onPlay(%this, %obj, %pos) {
  // callback
}
